codeforces 627B B. Factory Repairs(线段树)

B. Factory Repairs
time limit per test
4 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

A factory produces thimbles in bulk. Typically, it can produce up to a thimbles a day. However, some of the machinery is defective, so it can currently only produce b thimbles each day. The factory intends to choose a k-day period to do maintenance and construction; it cannot produce any thimbles during this time, but will be restored to its full production of a thimbles per day after the k days are complete.

Initially, no orders are pending. The factory receives updates of the form diai, indicating that ai new orders have been placed for thedi-th day. Each order requires a single thimble to be produced on precisely the specified day. The factory may opt to fill as many or as few of the orders in a single batch as it likes.

As orders come in, the factory owner would like to know the maximum number of orders he will be able to fill if he starts repairs on a given day pi. Help the owner answer his questions.

Input

The first line contains five integers nkab, and q (1 ≤ k ≤ n ≤ 200 000, 1 ≤ b < a ≤ 10 000, 1 ≤ q ≤ 200 000) — the number of days, the length of the repair time, the production rates of the factory, and the number of updates, respectively.

The next q lines contain the descriptions of the queries. Each query is of one of the following two forms:

  • di ai (1 ≤ di ≤ n1 ≤ ai ≤ 10 000), representing an update of ai orders on day di, or
  • pi (1 ≤ pi ≤ n - k + 1), representing a question: at the moment, how many orders could be filled if the factory decided to commence repairs on day pi?

It's guaranteed that the input will contain at least one query of the second type.

Output

For each query of the second type, print a line containing a single integer — the maximum number of orders that the factory can fill over all n days.

Examples
input
5 2 2 1 8
1 1 2
1 5 3
1 2 1
2 2
1 4 2
1 3 2
2 1
2 3
output
3
6
4
input
5 4 10 1 6
1 1 5
1 5 5
1 3 2
1 5 2
2 1
2 2
output
7
1
Note

Consider the first sample.

We produce up to 1 thimble a day currently and will produce up to 2 thimbles a day after repairs. Repairs take 2 days.

For the first question, we are able to fill 1 order on day 1, no orders on days 2 and 3 since we are repairing, no orders on day 4 since no thimbles have been ordered for that day, and 2 orders for day 5 since we are limited to our production capacity, for a total of 3 orders filled.

For the third question, we are able to fill 1 order on day 1, 1 order on day 2, and 2 orders on day 5, for a total of 4 orders.

题意:一台机器,n天时间,维修得k天,正常状况下生产a件产品,非正常状况下生产b件产品,维修期间不生产产品,1下是在第d天生产ai件产品,2下是在第pi天开始维修,问在每个2下输出n天最多生产了多少件产品;

思路:线段树,维护两个和,sum[0]是这个区间内正常情况下最多生产的件数,sum[1]是在非正常情况下最多生产的件数,把(1,pi-1)的sum[0]+(pi+k,n)的sum[1]就是所要求的结果;

AC代码:

#include <bits/stdc++.h>
using namespace std;
const int N=1e6+6;
int n,k,a,b,q;
struct nod
{
    int l,r,len,sum[2];
};
nod tree[4*N];
void build(int node,int le,int ri)
{
    tree[node].l=le;
    tree[node].r=ri;
    tree[node].len=ri-le+1;
    for(int i=0;i<2;i++)
    {
        tree[node].sum[i]=0;
    }
    if(le==ri)return ;
    else
    {
        int mid=(ri+le)>>1;
        build(2*node,le,mid);
        build(2*node+1,mid+1,ri);
    }
}
void update(int node,int fx,int fy)
{
    if(tree[node].l==tree[node].r&&tree[node].l==fx)
    {
        if(fy+tree[node].sum[0]>=a)
        {
            tree[node].sum[0]=a;
        }
        else tree[node].sum[0]+=fy;
        if(fy+tree[node].sum[1]>=b)
        {
            tree[node].sum[1]=b;
        }
        else tree[node].sum[1]+=fy;
        return ;
    }
    int mid=(tree[node].l+tree[node].r)>>1;
    if(fx<=mid)update(2*node,fx,fy);
    else update(2*node+1,fx,fy);
    for(int i=0;i<2;i++)
    {
        tree[node].sum[i]=tree[2*node].sum[i]+tree[2*node+1].sum[i];
    }
}
int query(int node,int L,int R,int le,int ri,int pos)
{
    if(L>R)return 0;
    if(L<=le&&R>=ri)
    {
        return tree[node].sum[pos];
    }
    int mid=(le+ri)>>1;
    if(R<=mid) return query(2*node,L,R,le,mid,pos);
    else if(L>mid)return query(2*node+1,L,R,mid+1,ri,pos);else{return query(2*node,L,R,le,mid,pos)+query(2*node+1,L,R,mid+1,ri,pos);}}int main(){int flag,x,y;
    scanf("%d%d%d%d%d",&n,&k,&a,&b,&q);
    build(1,1,n);for(int i=0;i<q;i++){
        scanf("%d",&flag);if(flag==1){
            scanf("%d%d",&x,&y);
            update(1,x,y);}else{
            scanf("%d",&x);
            printf("%d\n",query(1,1,x-1,1,n,1)+query(1,x+k,n,1,n,0));

}

}
return0;
}
posted @ 2016-03-03 14:46  LittlePointer  阅读(312)  评论(0编辑  收藏  举报